<script>
    import {loadApiData} from "../LoadApiData";
    import {onMount} from "svelte";
    import {customers} from "../stores";

    onMount(async () => {
        await loadApiData("http://localhost:8081/api/v1/customers/", customers);
    });

    let sortBy = {col: "firstName", ascending: true};

    $: sort = (column) => {

        if (sortBy.col == column) {
            sortBy.ascending = !sortBy.ascending
        } else {
            sortBy.col = column
            sortBy.ascending = true
        }

        // Modifier to sorting function for ascending or descending
        let sortModifier = (sortBy.ascending) ? 1 : -1;

        let sort = (a, b) =>
            (a[column] < b[column])
                ? -1 * sortModifier
                : (a[column] > b[column])
                    ? 1 * sortModifier
                    : 0;

        $customers = $customers.sort(sort);
    }

</script>

<h1>Customers</h1>
<table>
    <tr>
        <th on:click={sort("firstName")}>First name</th>
        <th on:click={sort("lastName")}>Last name</th>
        <th on:click={sort("address")}>Address</th>
<!--        <th>Orders</th>-->
<!--        <th></th>-->
    </tr>
    {#each $customers as customer}
        <tr>
            <td>{customer.firstName}</td>
            <td>{customer.lastName}</td>
            <td>{customer.address}</td>
<!--            <td>{customer.orders.length}</td>-->
<!--            <td></td>-->
        </tr>
    {/each}
</table>